﻿Public Class frmStart
  Friend Shared MyIP, HomeChan, D1HashPath, W2HashPath, CRevPath As String
  Private Delegate Sub CallBack(Obj As Object)
  Friend Shared Sub LogData(Message As String)
    My.Computer.FileSystem.WriteAllText(Application.StartupPath & "\Log.txt", Message & vbNewLine, True)
  End Sub
  Friend Sub SetStatus(Message As String)
    If InvokeRequired Then
      BeginInvoke(New CallBack(AddressOf SetStatus), Message)
    Else
      lblStatus.Text = Message
    End If
  End Sub
  Private Class TCPProxy
    Implements IDisposable
    Private Const BUFFER_SIZE As Integer = 102400
    Private sckGAMEServer As Net.Sockets.TcpClient
    Private sckBNETClient As Net.Sockets.TcpClient
    Private sckUDPSpoof As Net.Sockets.UdpClient
    Private cCDKey, MPQName As String
    Private ClientToken, ServerToken As UInt32
    Private inBuffer, outBuffer, valBuffer As Byte()
    Private sStatString() As Byte
    Private LastWhisperUser As String
    Private pktBuffers As Collection
    Private DoBuffer As Boolean
    Private sServer As String
    Private WithEvents d1Client As clsDRTLClient

    Public Sub Close()
      If frmStart.InvokeRequired Then
        frmStart.Invoke(New MethodInvoker(AddressOf Close))
      Else
        If d1Client IsNot Nothing Then
          d1Client.Dispose()
          d1Client = Nothing
        End If
        If sckUDPSpoof IsNot Nothing Then
          sckUDPSpoof.Close()
          sckUDPSpoof = Nothing
        End If
        If sckBNETClient IsNot Nothing Then
          sckBNETClient.Close()
          sckBNETClient = Nothing
        End If
        If sckGAMEServer IsNot Nothing Then
          sckGAMEServer.Close()
          sckGAMEServer = Nothing
        End If
      End If
    End Sub
    Public Sub New(address As String, tcpServer As Net.Sockets.TcpClient, CDKey As String)
      sServer = address
      DoBuffer = False
      sckGAMEServer = tcpServer
      cCDKey = CDKey
      sckBNETClient = New Net.Sockets.TcpClient()
      GameListen()
    End Sub
    Private Sub ConnectToBNet()
      If sckBNETClient Is Nothing OrElse Not sckBNETClient.Connected Then
        sckBNETClient = New Net.Sockets.TcpClient()
        sckBNETClient.Connect(sServer, 6112)
        BnetListen()
      End If
    End Sub
    Private Sub GameListen()
      Do Until outBuffer Is Nothing
        Application.DoEvents()
      Loop
      ReDim outBuffer(BUFFER_SIZE - 1)
      Try
        sckGAMEServer.Client.BeginReceive(outBuffer, 0, BUFFER_SIZE, Net.Sockets.SocketFlags.None, New AsyncCallback(AddressOf sckGAMEServer_Receive), sckGAMEServer)
      Catch ex As Exception
        Me.Dispose()
        Exit Sub
      End Try
    End Sub
    Private Sub BnetListen()
      Do Until inBuffer Is Nothing
        Application.DoEvents()
      Loop
      ReDim inBuffer(BUFFER_SIZE - 1)
      Try
        sckBNETClient.Client.BeginReceive(inBuffer, 0, BUFFER_SIZE, Net.Sockets.SocketFlags.None, New AsyncCallback(AddressOf sckBNETClient_Receive), sckBNETClient)
      Catch ex As Exception
        Me.Dispose()
        Exit Sub
      End Try
    End Sub

    Private Enum ChatEventTypes As UInt32
      SHOWUSER = 1
      JOIN = 2
      LEAVE = 3
      WHISPER = 4
      TALK = 5
      BROADCAST = 6
      CHANNEL = 7
      USERFLAGS = 9
      WHISPERSENT = &HA
      CHANNELFULL = &HD
      CHANNELDOESNOTEXIST = &HE
      CHANNELRESTRICTED = &HF
      INFO = &H12
      [ERROR] = &H13
      IGNORE = &H15
      ACCEPT = &H16
      EMOTE = &H17
    End Enum

    Private Sub SendMessagebox(Text As String, Optional Style As MsgBoxStyle = MsgBoxStyle.OkOnly, Optional Title As String = "Diablo I to Warcraft II Proxy")
      Using pktMsgBox As New BNCSPacket(&H19)
        pktMsgBox.InsertUInt32(Style)
        pktMsgBox.InsertCString(Text)
        pktMsgBox.InsertCString(Title)
        sckGAMEServer.Client.Send(pktMsgBox.GetData)
      End Using
    End Sub
    Private Sub SendChatEvent(EventType As ChatEventTypes, Username As String, Text As String)
      Using pktEvent As New BNCSPacket(&HF)
        pktEvent.InsertUInt32(EventType)
        pktEvent.InsertUInt32(0)
        pktEvent.InsertUInt32(0)
        pktEvent.InsertUInt32(0)
        pktEvent.InsertUInt32(0)
        pktEvent.InsertUInt32(0)
        pktEvent.InsertCString(Username)
        pktEvent.InsertCString(Text)
        sckGAMEServer.Client.Send(pktEvent.GetData)
      End Using
    End Sub

    Private Sub sckGAMEServer_Receive(ar As IAsyncResult)
      If sckGAMEServer Is Nothing Then Exit Sub
      Dim iLen As Integer
      Try
        iLen = sckGAMEServer.Client.EndReceive(ar)
      Catch ex As Exception
        Me.Dispose()
        Exit Sub
      End Try
      If iLen > 0 Then
        Dim bRet(iLen - 1) As Byte
        Array.Copy(outBuffer, 0, bRet, 0, iLen)
        Erase outBuffer
        If Not sckBNETClient.Connected Then ConnectToBNet()
        Dim iStart As Integer = 0
        Do
          If bRet(iStart) = &HFF Then
            Dim bTmp(bRet.Length - iStart - 1) As Byte
            Array.Copy(bRet, iStart, bTmp, 0, bRet.Length - iStart)
            Dim pktTmp As New BNCSReader(bTmp)
            If pktTmp.Length < 1 Then Exit Do
            ReDim Preserve bTmp(pktTmp.Length - 1)
            Select Case pktTmp.PacketID
              Case &H6 'STARTVERSIONING
                Using newPkt As New BNCSPacket(&H6)
                  newPkt.InsertUInt32(pktTmp.ReadUInt32)
                  newPkt.InsertDwordString("W2BN")
                  newPkt.InsertUInt32(&H4F)
                  newPkt.InsertUInt32(0)
                  bTmp = newPkt.GetData
                End Using
              Case &H7 'REPORTVERSION
                Using newPkt As New BNCSPacket(&H7)
                  newPkt.InsertUInt32(pktTmp.ReadUInt32)
                  newPkt.InsertDwordString("W2BN")
                  newPkt.InsertUInt32(&H4F)
                  Dim HashFiles(2) As String
                  Dim BINFile As String = Nothing
                  Dim EXEVer As Int32
                  Dim EXEHash As Int32
                  Dim EXEInfo() As Byte
                  GetHashFiles(HashFiles, BINFile)
                  For I As Integer = 0 To 2
                    If Not My.Computer.FileSystem.FileExists(HashFiles(I)) Then
                      SendMessagebox(HashFiles(I) & " not found!" & vbNewLine & "Please check your hash directory settings.", MsgBoxStyle.Exclamation)
                      frmStart.SetStatus(HashFiles(I) & " not found!")
                      LogData(HashFiles(I) & " not found")
                      Close()
                      Exit Sub
                    End If
                  Next I
                  If Not My.Computer.FileSystem.FileExists(BINFile) Then
                    SendMessagebox(BINFile & " not found!" & vbNewLine & "Please check your hash directory settings.", MsgBoxStyle.Exclamation)
                    frmStart.SetStatus(BINFile & " not found!")
                    LogData(BINFile & " not found")
                    Close()
                    Exit Sub
                  End If
                  If MPQName.ToLower.Contains("ix86") Then
                    If MPQName.ToLower.Contains("ver") Then
                      Dim sRequest = System.Text.Encoding.GetEncoding(28591).GetString(valBuffer)
                      Dim EXEInfoS As String = String.Empty
                      EXEVer = CheckRevision.GetExeInfo(HashFiles(0), EXEInfoS)
                      EXEHash = CheckRevision.DoCheckRevision(sRequest, HashFiles, CheckRevision.ExtractMPQNumber(MPQName))
                      EXEInfo = System.Text.Encoding.GetEncoding(28591).GetBytes(EXEInfoS)
                    ElseIf MPQName.ToLower.Contains("lockdown") Then
                      Dim DLLPath As String = CRevPath & "\" & MPQName.Substring(0, InStr(MPQName, ".")) & "dll"
                      If Not My.Computer.FileSystem.FileExists(DLLPath) Then
                        SendMessagebox(IO.Path.GetFileName(DLLPath) & " was not found!", MsgBoxStyle.Exclamation)
                        frmStart.SetStatus(DLLPath & " not found!")
                        LogData("Need " & DLLPath)
                        Close()
                        Exit Sub
                      End If
                      EXEInfo = Lockdown.CheckRevision(valBuffer, HashFiles, DLLPath, BINFile, EXEVer, EXEHash)
                    Else
                      SendMessagebox("Unknown CheckRevision request.", MsgBoxStyle.Exclamation)
                      frmStart.SetStatus("Unknown CheckRevision Request:" & vbNewLine & MPQName & " - " & BitConverter.ToString(valBuffer))
                      LogData("Unknown CRev: " & MPQName & " - " & BitConverter.ToString(valBuffer))
                      Close()
                      Exit Sub
                    End If
                  ElseIf MPQName.ToLower.Contains("pmac") Then
                    SendMessagebox("PMAC is not supported.", MsgBoxStyle.Exclamation)
                    frmStart.SetStatus("PMAC connection not supported")
                    LogData("PMAC not supported")
                    Close()
                    Exit Sub
                  ElseIf MPQName.ToLower.Contains("xmac") Then
                    SendMessagebox("XMAC is not supported.", MsgBoxStyle.Exclamation)
                    frmStart.SetStatus("XMAC connection not supported")
                    LogData("XMAC Not Supported")
                    Close()
                    Exit Sub
                  Else
                    SendMessagebox("Unknown CheckRevision request.", MsgBoxStyle.Exclamation)
                    frmStart.SetStatus("Unknown CheckRevision Request:" & vbNewLine & MPQName & " - " & BitConverter.ToString(valBuffer))
                    LogData("Unknown CRev: " & MPQName & " - " & BitConverter.ToString(valBuffer))
                    Close()
                    Exit Sub
                  End If
                  newPkt.InsertInt32(EXEVer)
                  newPkt.InsertInt32(EXEHash)
                  newPkt.InsertByteArray(EXEInfo)
                  newPkt.InsertByte(0)
                  bTmp = newPkt.GetData
                End Using
              Case &HA 'ENTERCHAT
                pktTmp.ReadCString()
                sStatString = pktTmp.ReadNullTerminatedByteArray
                If d1Client Is Nothing Then
                  d1Client = New clsDRTLClient("D1toW2", "drtltow2bn", sStatString, sckBNETClient.Client.RemoteEndPoint, D1HashPath, CRevPath)
                Else
                  d1Client.LeaveGame()
                End If
              Case &HC 'JOINCHANNEL
                Dim JType As UInt32 = pktTmp.ReadUInt32
                If JType = 1 Then
                  Using pktJoin As New BNCSPacket(&HC)
                    pktJoin.InsertUInt32(&H2)
                    pktJoin.InsertCString(HomeChan)
                    bTmp = pktJoin.GetData
                  End Using
                End If
              Case &HE 'CHATCOMMAND
                Dim sText As String = pktTmp.ReadCString
                Dim sRep As String = Nothing
                If sText.StartsWith("/") Then
                  Dim sCMD() As String
                  If InStr(sText, " ") > 0 Then
                    sCMD = Split(sText.Substring(1), " ", 2)
                  Else
                    ReDim sCMD(0)
                    sCMD(0) = sText.Substring(1)
                  End If
                  Select Case sCMD(0).ToLower
                    Case "ver", "v" : sRep = "/me is running D1toW2 v" & Application.ProductVersion & " (Diablo 1.09 through Warcraft II BNE 2.0.2)"
                    Case "home" : sRep = "/join " & HomeChan
                    Case "sethome"
                      If sCMD.Count > 1 Then
                        HomeChan = sCMD(1)
                      Else
                        HomeChan = "Diablo USA-1"
                      End If
                      SendChatEvent(ChatEventTypes.INFO, "D1toW2", "Home channel set to " & HomeChan & ".")
                      bTmp = Nothing
                    Case "r", "reply", "respond" : sRep = "/w " & LastWhisperUser & " " & sCMD(1)
                  End Select
                End If
                If Not String.IsNullOrEmpty(sRep) Then
                  Using pktChat As New BNCSPacket(&HE)
                    pktChat.InsertCString(sRep)
                    bTmp = pktChat.GetData
                  End Using
                End If
              Case &H29 'LOGONRESPONSE
                ClientToken = pktTmp.ReadUInt32
                ServerToken = pktTmp.ReadUInt32
              Case &H1C 'STARTADVEX3
                Dim State As UInt32 = pktTmp.ReadUInt32
                Dim Uptime As UInt32 = pktTmp.ReadUInt32
                Dim Type As UInt16 = pktTmp.ReadUInt16
                Dim SubType As UInt16 = pktTmp.ReadUInt16
                Dim Provider As UInt32 = pktTmp.ReadUInt32
                Dim Ladder As UInt32 = pktTmp.ReadUInt32
                Dim GName As String = pktTmp.ReadCString
                Dim GPass As String = pktTmp.ReadCString
                Dim GStat As String = pktTmp.ReadCString
                If d1Client.Online Then
                  d1Client.BNCS_STARTADVEX3_Send(State, Uptime, Type, SubType, Provider, Ladder, GName, GPass, GStat)
                Else
                  LogData("Couldn't send over D1 Client. Not online!")
                End If
              Case &H10 'LEAVECHAT
                If d1Client.Online Then
                  d1Client.BNCS_LEAVECHAT_Send()
                Else
                  LogData("Couldn't send over D1 Client. Not online!")
                End If
              Case &H2 'STOPADV
                If d1Client.Online Then
                  d1Client.BNCS_STOPADV_Send()
                Else
                  LogData("Couldn't send over D1 Client. Not online!")
                End If
              Case &H9 'GETADVLISTEX
                Dim GameType As UInt16 = pktTmp.ReadUInt16
                Dim GameSubType As UInt16 = pktTmp.ReadUInt16
                Dim Filter As UInt32 = pktTmp.ReadUInt32
                Dim Reserved As UInt32 = pktTmp.ReadUInt32
                Dim GameCount As UInt32 = pktTmp.ReadUInt32
                Dim GameName As String = pktTmp.ReadCString
                Dim GamePass As String = pktTmp.ReadCString
                Dim GameStat As String = pktTmp.ReadCString
                If d1Client.Online Then
                  d1Client.BNCS_GETADVLISTEX_Send(GameType, GameSubType, Filter, Reserved, GameCount, GameName, GamePass, GameStat)
                  bTmp = Nothing
                Else
                  LogData("Couldn't send over D1 Client. Not online!")
                End If
              Case &H22 'NOTIFYJOIN
                Dim ProductID As UInt32 = pktTmp.ReadUInt32
                Dim ProductVer As UInt32 = pktTmp.ReadUInt32
                Dim GameName As String = pktTmp.ReadCString
                Dim GamePass As String = pktTmp.ReadCString
                If d1Client.Online Then
                  d1Client.BNCS_NOTIFYJOIN_Send(ProductID, ProductVer, GameName, GamePass)
                  bTmp = Nothing
                Else
                  LogData("Couldn't send over D1 Client. Not online!")
                End If
            End Select
            If bTmp IsNot Nothing Then
              If DoBuffer Then
                pktBuffers.Add(bTmp)
              Else
                Try
                  sckBNETClient.Client.Send(bTmp)
                Catch ex As Exception
                  Me.Dispose()
                  Exit Sub
                End Try
              End If
            End If
            iStart += pktTmp.Length
          Else
            If DoBuffer Then
              pktBuffers.Add(bRet)
            Else
              Dim bTmp As Byte = bRet(iStart)
              If bTmp = 1 Then
                Try
                  sckBNETClient.Client.Send({bTmp})
                Catch ex As Exception
                  Me.Dispose()
                  Exit Sub
                End Try
                iStart += 1
              Else
                Try
                  sckBNETClient.Client.Send(bRet)
                Catch ex As Exception
                  Me.Dispose()
                  Exit Sub
                End Try
                iStart += bRet.Length
              End If
            End If
          End If
        Loop While iStart < bRet.Length
      End If
      GameListen()
    End Sub
    Private Sub sckBNETClient_Receive(ar As IAsyncResult)
      If sckBNETClient Is Nothing Then Exit Sub
      Dim iLen As Integer
      Try
        iLen = sckBNETClient.Client.EndReceive(ar)
      Catch ex As Exception
        Me.Dispose()
        Exit Sub
      End Try
      If iLen > 0 Then
        Dim bRet(iLen - 1) As Byte
        Array.Copy(inBuffer, 0, bRet, 0, iLen)
        Erase inBuffer
        If Not sckBNETClient.Connected Then ConnectToBNet()
        Dim iStart As Integer = 0
        Do
          If bRet(iStart) = &HFF Then
            Dim bTmp(bRet.Length - iStart - 1) As Byte
            Array.Copy(bRet, iStart, bTmp, 0, bRet.Length - iStart)
            Dim pktTmp As New BNCSReader(bTmp)
            If pktTmp.Length = 0 Then Exit Do
            ReDim Preserve bTmp(pktTmp.Length - 1)
            Select Case pktTmp.PacketID
              Case &H6 'STARTVERSIONING
                Dim fT As UInt64 = pktTmp.ReadUInt64
                MPQName = pktTmp.ReadCString
                valBuffer = pktTmp.ReadNullTerminatedByteArray
                Dim bUDP() As Byte = {&H5, &H0, &H0, &H0, &H74, &H65, &H6E, &H62}
                sckUDPSpoof = New Net.Sockets.UdpClient
                sckUDPSpoof.Client.SendTo(bUDP, New Net.IPEndPoint(Net.IPAddress.Parse(MyIP), 6112))
              Case &H29 'LOGONRESPONSE
                Dim iRet As UInt32 = pktTmp.ReadUInt32
                If iRet = 1 Then
                  Using pktCD2 As New BNCSPacket(&H36)
                    Dim Key As New clsKey(cCDKey)
                    If Key.IsValid Then
                      If ClientToken > 0 And ServerToken > 0 Then
                        pktCD2.InsertBoolean(False)
                        pktCD2.InsertUInt32(16)
                        pktCD2.InsertUInt32(Key.Product)
                        pktCD2.InsertUInt32(Key.PublicVal)
                        pktCD2.InsertUInt32(ServerToken)
                        pktCD2.InsertUInt32(ClientToken)
                        pktCD2.InsertByteArray(Key.GetHash(ClientToken, ServerToken, False))
                        pktCD2.InsertCString("RealityRipple")
                      Else
                        SendMessagebox("No Tokens Set!", MsgBoxStyle.Exclamation)
                        frmStart.SetStatus("No Client or Server Token Set!")
                        LogData("No Client or Server Token Set!")
                        Close()
                        Exit Sub
                      End If
                    Else
                      SendMessagebox("Invalid CD-Key", MsgBoxStyle.Exclamation)
                      frmStart.SetStatus("Invalid CD-Key")
                      LogData("Invalid CD Key")
                      Close()
                      Exit Sub
                    End If
                    Try
                      sckBNETClient.Client.Send(pktCD2.GetData)
                    Catch ex As Exception
                      Me.Dispose()
                      Exit Sub
                    End Try
                    pktBuffers = New Collection
                    DoBuffer = True
                  End Using
                End If
              Case &H36 'CDKEY2
                Dim lRet As UInt32 = pktTmp.ReadUInt32
                If lRet = 1 Then
                  For Each buf As Byte() In pktBuffers
                    sckBNETClient.Client.Send(buf)
                  Next
                  DoBuffer = False
                  iStart += pktTmp.Length
                  Continue Do
                End If
                Dim sMsg As String = pktTmp.ReadCString
                Dim sErr As String = "CDKey Failure: " & lRet
                Select Case lRet
                  Case 2 : sErr = "Invalid CDKey"
                  Case 3 : sErr = "Wrong CDKey Product"
                  Case 4 : sErr = "CDKey Banned"
                  Case 5 : sErr = "CDKey In Use"
                End Select
                SendMessagebox(sErr & vbNewLine & vbNewLine & sMsg, MsgBoxStyle.Exclamation)
                Close()
                frmStart.SetStatus(sErr)
                LogData(sErr)
                Exit Sub
                'Case &H9
                '  Dim GameCount As Integer = pktTmp.ReadUInt32
                '  If GameCount > 0 Then
                '    Using pktGame As New BNCSPacket(&H9)
                '      pktGame.InsertUInt32(GameCount)
                '      For Game As Integer = 1 To GameCount
                '        pktGame.InsertUInt16(pktTmp.ReadUInt16)
                '        pktGame.InsertUInt16(pktTmp.ReadUInt16)
                '        pktGame.InsertUInt32(pktTmp.ReadUInt32)
                '        pktGame.InsertUInt16(pktTmp.ReadUInt16)
                '        pktTmp.ReadInt16()
                '        pktGame.InsertInt16(Net.IPAddress.NetworkToHostOrder(6113S))
                '        pktGame.InsertUInt32(pktTmp.ReadUInt32)
                '        pktGame.InsertUInt32(pktTmp.ReadUInt32)
                '        pktGame.InsertUInt32(pktTmp.ReadUInt32)
                '        pktGame.InsertUInt32(pktTmp.ReadUInt32)
                '        pktGame.InsertUInt32(pktTmp.ReadUInt32)
                '        pktGame.InsertCString(pktTmp.ReadCString)
                '        pktGame.InsertCString(pktTmp.ReadCString)
                '        pktGame.InsertCString(pktTmp.ReadCString)
                '      Next
                '      bTmp = pktGame.GetData
                '    End Using
                '  End If
              Case &HA 'ENTERCHAT
                If sStatString IsNot Nothing Then
                  Using pktStat As New BNCSPacket(&HA)
                    pktStat.InsertCString(pktTmp.ReadCString)
                    pktTmp.ReadCString()
                    pktStat.InsertByteArray(sStatString) : pktStat.InsertByte(0)
                    pktStat.InsertCString(pktTmp.ReadCString)
                    bTmp = pktStat.GetData
                  End Using
                End If
              Case &HB 'CHANNELLIST
                'bTmp = Nothing
                Using newList As New BNCSPacket(&HB)
                  newList.InsertCString("Blizzard Tech Support")
                  newList.InsertCString("Open Tech Support")
                  newList.InsertCString("Beginners Only")
                  newList.InsertCString("Town Square")
                  newList.InsertCString("Trading Post")
                  newList.InsertCString("Adventurers Wanted")
                  newList.InsertCString("Bounty Hunters")
                  newList.InsertCString("Guild Recruitment")
                  newList.InsertCString("Guild Members")
                  newList.InsertCString("Warriors Arena")
                  newList.InsertCString("Rogues Gallery")
                  newList.InsertCString("Sorcerers Tower")
                  newList.InsertCString("Veterans Lounge (L20+)")
                  newList.InsertCString("The Black Lounge (L30+)")
                  newList.InsertCString("Hell's Caretakers (L30+)")
                  newList.InsertByte(0)
                  bTmp = newList.GetData
                End Using
              Case &HF 'CHATEVENT
                If pktTmp.ReadUInt32 = ChatEventTypes.WHISPER Then
                  pktTmp.ReadUInt32()
                  pktTmp.ReadUInt32()
                  pktTmp.ReadUInt32()
                  pktTmp.ReadUInt32()
                  pktTmp.ReadUInt32()
                  LastWhisperUser = pktTmp.ReadCString
                End If
              Case &H1C 'STARTADVEX3
                'ignore this one
                'bTmp = Nothing
              Case &H9 'GETADVLISTEX
                'ignore this too
                If d1Client.Online Then bTmp = Nothing
            End Select
            If bTmp IsNot Nothing Then
              Try
                sckGAMEServer.Client.Send(bTmp)
              Catch ex As Exception
                Me.Dispose()
                Exit Sub
              End Try
            End If
            iStart += pktTmp.Length
          Else
            Dim bTmp As Byte = bRet(iStart)
            If bTmp = 1 Then
              Try
                sckGAMEServer.Client.Send({bTmp})
              Catch ex As Exception
                Me.Dispose()
                Exit Sub
              End Try
              iStart += 1
            Else
              Try
                sckGAMEServer.Client.Send(bRet)
              Catch ex As Exception
                Me.Dispose()
                Exit Sub
              End Try
              iStart += bRet.Length
            End If
          End If
        Loop While iStart < bRet.Length
      End If
      BnetListen()
    End Sub

    Private Sub d1Client_IsOnline() Handles d1Client.IsOnline
      SendChatEvent(ChatEventTypes.INFO, "D1toW2", "Diablo compatibility client ready. You may now create and join Diablo games.")
    End Sub

    Private Sub d1Client_SendToGame(data() As Byte) Handles d1Client.SendToGame
      sckGAMEServer.Client.Send(data)
    End Sub

    Private Sub GetHashFiles(ByRef HashFiles() As String, ByRef BINFile As String)
      HashFiles(0) = W2HashPath & "\Warcraft II BNE.exe"
      HashFiles(1) = W2HashPath & "\Storm.dll"
      HashFiles(2) = W2HashPath & "\Battle.snp"
      BINFile = W2HashPath & "\W2BN.bin"
    End Sub
#Region "IDisposable Support"
    Private disposedValue As Boolean
    Protected Overridable Sub Dispose(disposing As Boolean)
      If Not Me.disposedValue Then
        If disposing Then
          Close()
        End If
      End If
      Me.disposedValue = True
    End Sub
    Public Sub Dispose() Implements IDisposable.Dispose
      Dispose(True)
      GC.SuppressFinalize(Me)
    End Sub
#End Region
  End Class
  Private sckTCPListener As Net.Sockets.TcpListener
  Private sckTCPPipes As Collection
  Private sServer, sCDKey As String
  Private bStart As Boolean
  Private Sub frmStart_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    MyIP = My.Settings.IP
    If Not Array.Exists(Net.Dns.GetHostAddresses(Net.Dns.GetHostName), Function(addr As Net.IPAddress) addr.AddressFamily = Net.Sockets.AddressFamily.InterNetwork And addr.ToString = MyIP) Then
      MyIP = Array.Find(Net.Dns.GetHostAddresses(Net.Dns.GetHostName), Function(addr As Net.IPAddress) addr.AddressFamily = Net.Sockets.AddressFamily.InterNetwork).ToString
      My.Settings.IP = MyIP
    End If
    HomeChan = My.Settings.Home
    If String.IsNullOrEmpty(HomeChan) Then HomeChan = "Diablo USA-1"
    D1HashPath = My.Settings.D1Hashes
    If String.IsNullOrEmpty(D1HashPath) Then D1HashPath = Application.StartupPath & "\Hashes\DRTL"
    W2HashPath = My.Settings.W2Hashes
    If String.IsNullOrEmpty(W2HashPath) Then W2HashPath = Application.StartupPath & "\Hashes\W2BN"
    CRevPath = My.Settings.CRev
    If String.IsNullOrEmpty(CRevPath) Then CRevPath = Application.StartupPath & "\CheckRevision Libraries"
    cmdDiablo.Enabled = My.Computer.Registry.CurrentUser.OpenSubKey("Software").GetSubKeyNames.Contains("Blizzard Entertainment") AndAlso
      My.Computer.Registry.CurrentUser.OpenSubKey("Software\Blizzard Entertainment").GetSubKeyNames.Contains("Diablo") AndAlso
      My.Computer.Registry.CurrentUser.OpenSubKey("Software\Blizzard Entertainment\Diablo").GetSubKeyNames.Contains("DelOpt0") AndAlso
      My.Computer.Registry.CurrentUser.OpenSubKey("Software\Blizzard Entertainment\Diablo\DelOpt0").GetValueNames.Contains("Path0")
    Dim sGateways As New ArrayList
    sGateways.AddRange(My.Computer.Registry.CurrentUser.OpenSubKey("Software\Battle.net\Configuration").GetValue("Battle.net gateways"))
    If sGateways.Contains(GATEWAYNAME) Then
      If Not sGateways.Contains(MyIP) Then
        sGateways.RemoveRange(sGateways.IndexOf(GATEWAYNAME) - 2, 3)
        sGateways.InsertRange(2, {MyIP, "0", GATEWAYNAME})
        My.Computer.Registry.CurrentUser.OpenSubKey("Software\Battle.net\Configuration", True).SetValue("Battle.net gateways", sGateways.ToArray(GetType(String)), Microsoft.Win32.RegistryValueKind.MultiString)
      End If
    End If
    bStart = My.Settings.Automatic
    tmrAutoStart.Enabled = True
  End Sub
  Private Sub cmdSettings_Click(sender As System.Object, e As System.EventArgs) Handles cmdSettings.Click
    If frmSettings.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
      MyIP = My.Settings.IP
      HomeChan = My.Settings.Home
      If String.IsNullOrEmpty(HomeChan) Then HomeChan = "Diablo USA-1"
      W2HashPath = My.Settings.W2Hashes
      If String.IsNullOrEmpty(W2HashPath) Then W2HashPath = Application.StartupPath & "\Hashes"
      CRevPath = My.Settings.CRev
      If String.IsNullOrEmpty(CRevPath) Then CRevPath = Application.StartupPath & "\CheckRevision Libraries"
    End If
  End Sub
  Private Sub cmdDiablo_Click(sender As System.Object, e As System.EventArgs) Handles cmdDiablo.Click
    Dim sDRTLPath As String = My.Computer.Registry.CurrentUser.OpenSubKey("Software\Blizzard Entertainment\Diablo\DelOpt0").GetValue("Path0") & "\"
    SetStatus("Running Diablo...")
    If My.Computer.FileSystem.FileExists(sDRTLPath & "DRTLNoCD.exe") Then
      Process.Start(sDRTLPath & "DRTLNoCD.exe")
      Me.WindowState = FormWindowState.Minimized
    ElseIf My.Computer.FileSystem.FileExists(sDRTLPath & "Diablo.exe") Then
      Process.Start(sDRTLPath & "Diablo.exe")
      Me.WindowState = FormWindowState.Minimized
    Else
      Beep()
    End If
  End Sub
  Private Sub cmdListen_Click(sender As System.Object, e As System.EventArgs) Handles cmdListen.Click
    If cmdListen.Text = "Listen" Then
      cmdListen.Text = "Stop"
      cmdSettings.Enabled = False
      sServer = My.Settings.Server
      sCDKey = My.Settings.CDKey
      Dim addrStr As String = Net.Dns.GetHostAddresses(sServer).FirstOrDefault.ToString
      If sckTCPListener IsNot Nothing Then
        sckTCPListener.Stop()
        sckTCPListener = Nothing
      End If
      sckTCPPipes = New Collection
      Try
        sckTCPListener = New Net.Sockets.TcpListener(Net.IPAddress.Parse(MyIP), 6112)
        sckTCPListener.Start(32)
      Catch ex As Exception
        SetStatus("Unable to Listen on port 6112 TCP" & vbNewLine & ex.Message)
        cmdListen.Text = "Listen"
        cmdSettings.Enabled = True
        If sckTCPListener IsNot Nothing Then
          sckTCPListener.Stop()
          sckTCPListener = Nothing
        End If
        Exit Sub
      End Try
      Listen()
      SetStatus("Listening on " & MyIP & ":6112...")
    Else
      cmdListen.Text = "Listen"
      cmdSettings.Enabled = True
      If sckTCPListener IsNot Nothing Then
        sckTCPListener.Stop()
        sckTCPListener = Nothing
      End If
      For Each socket As TCPProxy In sckTCPPipes
        socket.Close()
        socket.Dispose()
      Next
      sckTCPPipes.Clear()
      SetStatus("Idle. Press Listen, then Launch Diablo to begin.")
    End If
  End Sub
  Private Sub Listen()
    If cmdListen.Text = "Stop" Then sckTCPListener.BeginAcceptTcpClient(New AsyncCallback(AddressOf sckTCPListener_AcceptTCPClient), sckTCPListener)
  End Sub
  Private Sub sckTCPListener_AcceptTCPClient(ar As IAsyncResult)
    If sckTCPListener IsNot Nothing Then
      Dim Client As Net.Sockets.TcpClient
      Try
        Client = sckTCPListener.EndAcceptTcpClient(ar)
      Catch ex As Exception
        Exit Sub
      End Try
      SetStatus("Connection from " & Client.Client.RemoteEndPoint.ToString)
      sckTCPPipes.Add(New TCPProxy(sServer, Client, sCDKey))
      Listen()
    End If
  End Sub

  Private Sub tmrAutoStart_Tick(sender As System.Object, e As System.EventArgs) Handles tmrAutoStart.Tick
    tmrAutoStart.Enabled = False
    If My.Settings.Automatic And cmdDiablo.Enabled And bStart Then
      cmdListen.PerformClick()
      Application.DoEvents()
      cmdDiablo.PerformClick()
      bStart = False
    End If
  End Sub
  Private Sub tmrState_Tick(sender As System.Object, e As System.EventArgs) Handles tmrState.Tick
    If sckTCPListener Is Nothing Then
      cmdDiablo.Enabled = False
    Else
      If sckTCPListener.Server.IsBound Then
        cmdDiablo.Enabled = Process.GetProcessesByName("DIABLO").Count = 0
      Else
        cmdDiablo.Enabled = False
      End If
    End If
  End Sub
End Class
